/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 932 $ $LastChangedDate: 2002-09-11 17:06:10 +0200 (Wed, 11 Sep 2002) $
 *
 * Runtime environment for gont.
 */

#include <gont/runtime.h>
#include <string.h>

/* I guess this isn't used yet.  */

void *gont_memchr(void *haystack, gont_int haystack_len, gont_int ch)
{
	while (haystack_len--) {
		if (*(unsigned char*)haystack == ch)
			return haystack;
			
		haystack = (char*)haystack + 1;
	}

	return NULL;
}

void *gont_memrchr(void *haystack, gont_int haystack_len, gont_int ch)
{
	haystack = (char*)haystack + haystack_len - 1;

	while (haystack_len--) {
		if (*(unsigned char*)haystack == ch)
			return haystack;
			
		haystack = (char*)haystack - 1;
	}

	return NULL;
}

void *gont_memmem(void *haystack, gont_int haystack_len,
		  void *needle, gont_int needle_len)
{
	gont_int off, max;
	
	if (needle_len == 0)
		return haystack;

	if (needle_len > haystack_len)
		return NULL;
	
	max = haystack_len - needle_len;

	for (off = 0; off <= max; off++) {
		if (memcmp(haystack, needle, needle_len) == 0)
			return haystack;
		haystack = (char*)haystack + 1;
	}

	return NULL;
}

void *gont_memrmem(void *haystack, gont_int haystack_len,
		   void *needle, gont_int needle_len)
{
	long off;
	
	if (needle_len == 0)
		return haystack + haystack_len;

	if (needle_len > haystack_len)
		return NULL;
	
	off = haystack_len - needle_len;
	haystack = (char*)haystack + off;

	while (off-- >= 0) {
		if (memcmp(haystack, needle, needle_len) == 0)
			return haystack;
		haystack = (char*)haystack - 1;
	}

	return NULL;
}
